URLResource (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.types.resources, class: URLResource

# Class URLResource

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.types.DataType
org.apache.tools.ant.types.Resource
org.apache.tools.ant.types.resources.URLResource

All Implemented Interfaces:
  `Cloneable, Comparable<Resource>, Iterable<Resource>, ResourceCollection, URLProvider`

public class URLResource extends Resource implements URLProvider
Exposes a URL as a Resource.

Since:
  Ant 1.7

- ## Field Summary

  ### Fields inherited from class Resource

  `MAGIC, UNKNOWN_DATETIME, UNKNOWN_SIZE`
  Modifier and Type
  Field
  Description
  `protected static final int`
  `MAGIC`
  Magic number
  `static final long`
  `UNKNOWN_DATETIME`
  Constant unknown datetime for getLastModified
  `static final long`
  `UNKNOWN_SIZE`
  Constant unknown size

  ### Fields inherited from class DataType

  `checked, ref`
  Modifier and Type
  Field
  Description
  `protected boolean`
  `checked`
  Deprecated.
  since 1.7.
  `protected Reference`
  `ref`
  Deprecated.
  since 1.7.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `URLResource()`
  Default constructor.
  `URLResource(File f)`
  Convenience constructor.
  `URLResource(String u)`
  String constructor for Ant attribute introspection.
  `URLResource(URL u)`
  Convenience constructor.
  `URLResource(URLProvider u)`
  Convenience constructor.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected void`
  `connect()`
  Ensure that we have a connection.
  `protected void`
  `connect(int logLevel)`
  Ensure that we have a connection.
  `boolean`
  `equals(Object another)`
  Test whether an Object equals this URLResource.
  `InputStream`
  `getInputStream()`
  Get an InputStream for the Resource.
  `long`
  `getLastModified()`
  Tells the modification time in milliseconds since 01.01.1970 .
  `String`
  `getName()`
  Get the name of this URLResource (its file component minus the leading separator).
  `OutputStream`
  `getOutputStream()`
  Get an OutputStream for the Resource.
  `protected URLResource`
  `getRef()`
  Perform the check for circular references and return the referenced Resource.
  `long`
  `getSize()`
  Get the size of this Resource.
  `URL`
  `getURL()`
  Get the URL used by this URLResource.
  `int`
  `hashCode()`
  Get the hash code for this Resource.
  `boolean`
  `isDirectory()`
  Tells if the resource is a directory.
  `boolean`
  `isExists()`
  Find out whether the URL exists.
  `void`
  `setBaseURL(URL base)`
  Base URL which combined with the relativePath attribute defines the URL.
  `void`
  `setFile(File f)`
  Set the URL from a File.
  `void`
  `setRefid(Reference r)`
  Overrides the super version.
  `void`
  `setRelativePath(String r)`
  Relative path which combined with the baseURL attribute defines the URL.
  `void`
  `setURL(URL u)`
  Set the URL for this URLResource.
  `String`
  `toString()`
  Return this URLResource formatted as a String.

  ### Methods inherited from class Resource

  `as, asOptional, clone, compareTo, getMagicNumber, isFilesystemOnly, iterator, setDirectory, setExists, setLastModified, setName, setSize, size, toLongString`
  Modifier and Type
  Method
  Description
  `<T> T`
  `as(Class<T> clazz)`
  Returns a view of this resource that implements the interface given as the argument or null if there is no such view.
  `<T> Optional<T>`
  `asOptional(Class<T> clazz)`
  Return `Resource.as(Class)` as an `Optional`.
  `Object`
  `clone()`
  Clone this Resource.
  `int`
  `compareTo(Resource other)`
  Delegates to a comparison of names.
  `protected static int`
  `getMagicNumber(byte[] seed)`
  Create a "magic number" for use in hashCode calculations.
  `boolean`
  `isFilesystemOnly()`
  Fulfill the ResourceCollection contract.
  `Iterator<Resource>`
  `iterator()`
  Fulfill the ResourceCollection contract.
  `void`
  `setDirectory(boolean directory)`
  Set the directory attribute.
  `void`
  `setExists(boolean exists)`
  Set the exists attribute.
  `void`
  `setLastModified(long lastmodified)`
  Set the last modification attribute.
  `void`
  `setName(String name)`
  Set the name of this Resource.
  `void`
  `setSize(long size)`
  Set the size of this Resource.
  `int`
  `size()`
  Fulfill the ResourceCollection contract.
  `final String`
  `toLongString()`
  Get a long String representation of this Resource.

  ### Methods inherited from class DataType

  `checkAttributesAllowed, checkChildrenAllowed, circularReference, dieOnCircularReference, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, tooManyAttributes`
  Modifier and Type
  Method
  Description
  `protected void`
  `checkAttributesAllowed()`
  check that it is ok to set attributes, i.e that no reference is defined
  `protected void`
  `checkChildrenAllowed()`
  check that it is ok to add children, i.e that no reference is defined
  `protected BuildException`
  `circularReference()`
  Creates an exception that indicates the user has generated a loop of data types referencing each other.
  `protected void`
  `dieOnCircularReference()`
  Convenience method.
  `protected void`
  `dieOnCircularReference(Stack<Object> stack, Project project)`
  Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).
  `protected void`
  `dieOnCircularReference(Project p)`
  Convenience method.
  `protected <T> T`
  `getCheckedRef()`
  Deprecated.
  use getCheckedRef(Class)
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName, Project project)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Project p)`
  Deprecated.
  use getCheckedRef(Class)
  `protected String`
  `getDataTypeName()`
  Gets as descriptive as possible a name used for this datatype instance.
  `Reference`
  `getRefid()`
  get the reference set on this object
  `static void`
  `invokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected boolean`
  `isChecked()`
  The flag that is used to indicate that circular references have been checked.
  `boolean`
  `isReference()`
  Has the refid attribute of this element been set?
  `protected BuildException`
  `noChildrenAllowed()`
  Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.
  `static void`
  `pushAndInvokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected void`
  `setChecked(boolean checked)`
  Set the flag that is used to indicate that circular references have been checked.
  `protected BuildException`
  `tooManyAttributes()`
  Creates an exception that indicates that refid has to be the only attribute if it is set.

  ### Methods inherited from class ProjectComponent

  `getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface Iterable

  `forEach, spliterator`

  ### Methods inherited from interface ResourceCollection

  `isEmpty, stream`
  Modifier and Type
  Method
  Description
  `default boolean`
  `isEmpty()`
  Learn whether this `ResourceCollection` is empty.
  `default Stream<? extends Resource>`
  `stream()`
  Return a `Stream` over this `ResourceCollection`.

- ## Constructor Details

  - ### URLResource

    public URLResource()
    Default constructor.

  - ### URLResource

    public URLResource(URL u)
    Convenience constructor.
    Parameters:
      `u` - the URL to expose.

  - ### URLResource

    public URLResource(URLProvider u)
    Convenience constructor.
    Parameters:
      `u` - holds the URL to expose.

  - ### URLResource

    public URLResource(File f)
    Convenience constructor.
    Parameters:
      `f` - the File to set as a URL.

  - ### URLResource

    public URLResource(String u)
    String constructor for Ant attribute introspection.
    Parameters:
      `u` - String representation of this URL.
    See Also:
      - `IntrospectionHelper`

- ## Method Details

  - ### setURL

    public void setURL(URL u)
    Set the URL for this URLResource.
    Parameters:
      `u` - the URL to expose.

  - ### setFile

    public void setFile(File f)
    Set the URL from a File.
    Parameters:
      `f` - the File to set as a URL.

  - ### setBaseURL

    public void setBaseURL(URL base)
    Base URL which combined with the relativePath attribute defines the URL.
    Parameters:
      `base` - URL
    Since:
      Ant 1.8.0

  - ### setRelativePath

    public void setRelativePath(String r)
    Relative path which combined with the baseURL attribute defines the URL.
    Parameters:
      `r` - String
    Since:
      Ant 1.8.0

  - ### getURL

    public URL getURL()
    Get the URL used by this URLResource.
    Specified by:
      `getURL` in interface `URLProvider`
    Returns:
      a URL object.

  - ### setRefid

    public void setRefid(Reference r)
    Overrides the super version.
    Overrides:
      `setRefid` in class `Resource`
    Parameters:
      `r` - the Reference to set.

  - ### getName

    public String getName()
    Get the name of this URLResource (its file component minus the leading separator).
    Overrides:
      `getName` in class `Resource`
    Returns:
      the name of this resource.

  - ### toString

    public String toString()
    Return this URLResource formatted as a String.
    Overrides:
      `toString` in class `Resource`
    Returns:
      a String representation of this URLResource.

  - ### isExists

    public boolean isExists()
    Find out whether the URL exists.
    Overrides:
      `isExists` in class `Resource`
    Returns:
      true if this resource exists.

  - ### getLastModified

    public long getLastModified()
    Tells the modification time in milliseconds since 01.01.1970 .
    Overrides:
      `getLastModified` in class `Resource`
    Returns:
      0 if the resource does not exist to mirror the behavior of `File`.

  - ### isDirectory

    public boolean isDirectory()
    Tells if the resource is a directory.
    Overrides:
      `isDirectory` in class `Resource`
    Returns:
      boolean whether the resource is a directory.

  - ### getSize

    public long getSize()
    Get the size of this Resource.
    Overrides:
      `getSize` in class `Resource`
    Returns:
      the size, as a long, 0 if the Resource does not exist (for compatibility with java.io.File), or UNKNOWN_SIZE if not known.

  - ### equals

    public boolean equals(Object another)
    Test whether an Object equals this URLResource.
    Overrides:
      `equals` in class `Resource`
    Parameters:
      `another` - the other Object to compare.
    Returns:
      true if the specified Object is equal to this Resource.

  - ### hashCode

    public int hashCode()
    Get the hash code for this Resource.
    Overrides:
      `hashCode` in class `Resource`
    Returns:
      hash code as int.

  - ### getInputStream

    public InputStream getInputStream() throws IOException
    Get an InputStream for the Resource.
    Overrides:
      `getInputStream` in class `Resource`
    Returns:
      an InputStream containing this Resource's content.
    Throws:
      `IOException` - if unable to provide the content of this Resource as a stream.
      `UnsupportedOperationException` - if InputStreams are not supported for this Resource type.

  - ### getOutputStream

    public OutputStream getOutputStream() throws IOException
    Get an OutputStream for the Resource.
    Overrides:
      `getOutputStream` in class `Resource`
    Returns:
      an OutputStream to which content can be written.
    Throws:
      `IOException` - if unable to provide the content of this Resource as a stream.
      `UnsupportedOperationException` - if OutputStreams are not supported for this Resource type.
      `IOException` - if the URL cannot be opened.

  - ### connect

    protected void connect() throws IOException
    Ensure that we have a connection.
    Throws:
      `IOException` - if the connection cannot be established.

  - ### connect

    protected void connect(int logLevel) throws IOException
    Ensure that we have a connection.
    Parameters:
      `logLevel` - severity to use when logging connection errors. Should be one of the `MSG_` constants in `Project`.
    Throws:
      `IOException` - if the connection cannot be established.
    Since:
      Ant 1.8.2

  - ### getRef

    protected URLResource getRef()
    Description copied from class: `Resource`
    Perform the check for circular references and return the referenced Resource.
    Overrides:
      `getRef` in class `Resource`
    Returns:
      `Resource`.